#include "blargg/Nes_Apu.h"
#include "blargg/Blip_Buffer.h"

#include "../emu/h/types.h"
#include "../nes/h/nesGeneral.h"
#include "h/apu.h"
#include "h/cpu.h"
#include "h/registers.h"

namespace Reminesce
{

Nes_Apu apu;
Blip_Buffer blipBuf;


int dmc_reader(void *user_data, nes_addr_t addr)
{
	cpuCycles += 4;
	return Read6502(addr);
}

void resetTheApu()
{
	apu.reset((nesMode & regionModeAnd) == palMode);
}

int initApu()
{

	if ( blipBuf.sample_rate( samples_per_sec ) )
	{
		emuMsg("out of memory (initApu, sample_rate)");
		return 1;													// out of memory
	}

	blipBuf.clock_rate((nesMode & regionModeAnd) == palMode ? clocks_per_secPAL : clocks_per_secNTSC );
	apu.output( &blipBuf );											// Route APU output to buffer
	blip_time_t time = 0;
	apu.volume(1.0f);
	apu.dmc_reader(dmc_reader);
	resetTheApu();
	return 0;
}

void uninitApu()
{
}

}
