#include "../emu/h/types.h"
#include "h/nesGeneral.h"
#include "h/cpu.h"
#include "h/ppu.h"
#include "h/registers.h"
#include "h/cpuRegs.h"
#include "h/ppuRegs.h"
#include "../emu/h/interface.h"
#include "../emu/h/mapper.h"

#include "blargg/Nes_Apu.h"

#include "h/apu.h"

namespace Reminesce
{

char wramEnabled, wramWriteEnabled;
void bankWrite(int val, int addr);

int test=0;

void Write6502(u8 val, u16 addr)
{
	if (addr<0x2000)
	{
		pWrite(addr) = val;
	}
	else if (addr < 0x4000)
	{
		ppu.bus = val;
 		switch (addr & 7)
		{
		case 0: write2000(ppu.bus); break;
		case 1: write2001(ppu.bus); break;
		case 3: write2003(ppu.bus); break;
		case 4: write2004(ppu.bus); break;
		case 5: write2005(ppu.bus); break;
		case 6: write2006(ppu.bus); break;
		case 7: write2007(ppu.bus); break;
		}
	}
	else if (addr <= 0x4017)
	{
		switch (addr)
		{
		case 0x4014: write4014(val); break;
		case 0x4016: write4016(val); break;
		default:
			apu.write_register(cpuCycles, addr, val);
			break;
		}
	}
	else //4018-5FFF, 8000+
	{
		bankWrite(val, addr);
	}
}

u8 Read6502(u16 addr)
{
	switch (addr & 0xE000)
	{
	case 0x0000:
	case 0x8000:
	case 0xA000:
	case 0xC000:
	case 0xE000:
	case 0x6000:
		return pRead(addr);
		break;

	case 0x2000:
		switch (addr & 7)
		{
			case 2: read2002(); break;
			case 4: read2004(); break;
			case 7: read2007(); break;
		}

		return ppu.bus;
		break;
	case 0x4000:
		if (addr <= 0x4017)
		{
			switch (addr)
			{
				case 0x4015: return apu.read_status(cpuCycles); break;
				case 0x4016: return read4016(); break;
				case 0x4017: return read4017(); break;
				default: return 0x40;
			}
		}
		break;
	}
	return addr>>8;
}








void myWriteFunc(int bank, int where, int val)
{
	int addr = bank<<12 | where;

	if (addr<0x2000)
	{
		pWrite(addr) = val;
	}
	else if ((0x6000 <= addr) && (addr < 0x8000))
	{
		pWrite(addr) = val;
	}
	else if (addr < 0x4000)
	{
 		switch (addr & 7)
		{
		case 0: write2000(val); break;
		case 1: write2001(val); break;
		case 3: write2003(val); break;
		case 4: write2004(val); break;
		case 5: write2005(val); break;
		case 6: write2006(val); break;
		case 7: write2007(val); break;
		default: ppu.bus = val; break;
		}
	}
	else if (addr <= 0x4017)
	{
		switch (addr)
		{
		case 0x4014: write4014(val); break;
		case 0x4016: write4016(val); break;
		default:
			apu.write_register(cpuCycles, addr, val);
			break;
		}
	}
	else //4018-5FFF, 8000+
	{
	}
}

int  myReadFunc (int bank, int where)
{
	int addr = bank<<12 | where;
	switch (addr & 0xE000)
	{
	case 0x0000:
	case 0x8000:
	case 0xA000:
	case 0xC000:
	case 0xE000:
	case 0x6000:
		return pRead(addr);
		break;
	case 0x2000:
		switch (addr & 7)
		{
			case 2: read2002(); break;
			case 4: read2004(); break;
			case 7: read2007(); break;
		}
		return ppu.bus;
		break;
	case 0x4000:
		if (addr <= 0x4017)
		{
			switch (addr)
			{
				case 0x4015: return apu.read_status(cpuCycles); break;
				case 0x4016: return read4016(); break;
				case 0x4017: return read4017(); break;
			}
		}
		break;
	}
	return addr>>8;
}

}
